<template>
    <div class="main">
        <div class="container">
            <div class="row">
                <div class="col-sm">
                    <div id="searchLawyer" v-if="!result.length">
                        <div v-if="!listOn">
                            <section class="section has-padding-5" v-for="(log, index) in logs">
                                <h1 class="subtitle">
                                    {{ headlines[index] }}
                                </h1>
                                <div class="buttons are-medium has-padding-10">
                                    <button :disabled="step > index || last" @click="selectOption(option)" v-bind:class="{'btn-success': option.active, 'btn-outline-success': !option.active}" class="btn"  v-for="option in log" :title="option.description">{{ option.name }}</button>
                                </div>
                            </section>
                            <section class="section has-padding-10" v-if="last">
                                <h1 class="subtitle has-padding-10">It is about</h1>
                                <span class="tag is-success is-medium has-padding-10">{{last.name}}</span>
                                <h1 class="subtitle">Right ?</h1>
                                <div class="buttons are-medium has-padding-10">
                                    <button @click="setResult" class="btn btn-outline-success">yes</button>
                                    <button @click="listOn = true" class="btn btn-outline-danger">no</button>
                                </div>
                            </section>
                        </div>
                        <div v-else>
                            <section class="section">
                                <div class="content">
                                    <button @click="listOn = false" class="btn btn-warning float-right">  <i class="ni ni-bold-left"></i> Back</button><br>
                                    <h1 class="display-4 text-center mt-4">Choose the category which is related to your case</h1>
                                    <ul class="mt-4 list-group" type="1">
                                        <li class="list-group-item" v-for="category in categories"><a href="#" @click.prevent="setResult(category)">{{ category.name }}</a></li>
                                    </ul>
                                </div>
                            </section>
                        </div>
                    </div>
                    <div class="container has-padding-100" v-else>
                        <h1 class="display-4 text-center mt-4">We found the following lawyer associatet with your case</h1>
                        <lawyer-carousel :lawyers="result"></lawyer-carousel>
                        <div class="text-center">
                            <button @click="reset" type="button" class="btn btn-warning">Not the right one ?</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
    import lawyerCarousel from "./lawyercarousel.vue";
    export default {
        components: {
            lawyerCarousel
        },
        props: {
            categoriesD: {
                type: Array,
                default() {
                    return [
                        [
                            {
                                name: 'preload'
                            }
                        ],
                    ]
                }

            }
        },
        mounted() {
            this.getOptions()
            this.getCategories()
            this.getLawyers()
        },
        data() {
            return {
                result: [
                ],
                listOn: false,
                last: false,
                logs: [
                ],
                step: 0,
                headlines: ['What is it about ...'],
                selected: {},
                categories: [],
                options: [],
                lawyers: [],
                lastLawyers: []
            }
        },
        methods: {
            getCategories () {
                this.$axios.get(process.env.BACKEND_API+'/matchcategories').then(results => {
                    console.log('categories', results.data)
                    this.categories = results.data
                })
            },

            getOptions () {
                this.$axios.get(process.env.BACKEND_API+'/matchingflow').then(results => {
                    this.options = results.data
                    this.selected = this.options
                    this.logs.push(this.options)
                })
            },

            selectOption(option) {
                console.log(option)
                option.active = !option.active
                this.selected = option
                this.step++

                if("nextOption" in option) {
                    if (option.nextOption.length) {
                        this.headlines.push(option.headline)
                        this.logs.push(option.nextOption)
                    } else {
                        this.last = option
                    }
                } else {
                    this.last = option
                }
                if (this.last) {
                    let last = this.last
                    this.result = this.lawyers.filter(function(lawyer) {
                        return lawyer.profession == last.name;
                    });
                }
            },
            setResult(category) {
                this.result = this.lawyers.filter(function(lawyer) {
                    return lawyer.profession == category.name;
                });
            },
            reset() {
                this.result = []
                this.listOn = true
            },
            getLawyers() {
                this.$axios.get(process.env.BACKEND_API+'/find/all').then(results => {
                    this.lawyers = results.data
                })
            }
        }
    }
</script>
<style>
    .main {
        display: flex;
        min-height: 100vh;
        flex-direction: column;
    }

    .section {
        flex: 1;
    }
</style>